/*
 * DayTimeClient.java
 *
 * Created on October 31, 2001, 6:16 PM
 */

package examples;

import java.io.*;
import javax.microedition.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

/**
 *
 * @author  Paul Tremblett
 * @version 1.0
 */
public class DayTimeClient extends javax.microedition.midlet.MIDlet 
    implements CommandListener {

  Display display;

  private boolean commandAvailable;
  CommandThread commandThread;
  
  List menu;
  Form outputForm;
  StringItem dt;
      
  Command cmdBack;
  Command cmdExit;

  public void startApp() {
    
    display = Display.getDisplay(this);
    outputForm = new Form("Date/Time");
    dt = new StringItem(null,null);
    outputForm.append(dt);
    cmdBack = new Command("Back",Command.BACK,1);
    outputForm.addCommand(cmdBack);
    cmdExit = new Command("Exit",Command.EXIT,1);
    outputForm.addCommand(cmdExit);
    outputForm.setCommandListener(this);

    menu = new List("Menu",List.IMPLICIT);
    menu.append("Get Date/Time",null);
    menu.append("Exit",null);
    menu.setCommandListener(this);
    display.setCurrent(menu);

    commandAvailable = false;
    commandThread = new CommandThread(this);
    commandThread.start();
  }


  public void pauseApp() {
  }

  public void destroyApp(boolean unconditional) {
  }

  public void commandAction(Command cmd, Displayable d) {
    if (cmd == cmdExit) {
      destroyApp(false);
      notifyDestroyed();
    }
    else if (cmd == cmdBack) {
      display.setCurrent(menu);
    }
    else if ((d == menu) && (cmd == List.SELECT_COMMAND)) {
      synchronized (this) {
        commandAvailable = true;
        notify();
      }
    }
  }    

  class CommandThread extends Thread {
    MIDlet parent;

    InputConnection socket = null;
    InputStream is = null;

    boolean exit = false;

    public CommandThread(MIDlet parent) {
      this.parent = parent;
    }

      public void run() {
        while (!exit) {
          synchronized(parent) {
            while(!commandAvailable) {
              try {
                parent.wait();
              }
              catch (InterruptedException e) {
              }
            }
          }
          commandAvailable = false;
      
          switch (menu.getSelectedIndex()) {
            case 0:
              getDate();
              break;
            case 1:
              exit = true;
          }
        }
        destroyApp(false);
        notifyDestroyed(); 
      }

    public void getDate() {
      try {
        socket =
          (InputConnection)Connector.open("socket://127.0.0.1:13",
             Connector.READ, true);

        is = socket.openInputStream();
      }
      catch (Exception e) {
      }

      try {
        int b;
        StringBuffer sb = new StringBuffer();
        while ( (b = is.read()) != -1) {
          sb.append((char)b);
        }
        socket.close();
        dt.setText(sb.toString());
        display.setCurrent(outputForm);
      }
      catch (Exception e) {
      }
    }
  }
}

