/*
 * SessionDemo.java
 *
 * Created on October 31, 2001, 7:56 PM
 */

package examples;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.Connector;
import javax.microedition.io.ContentConnection;
import javax.microedition.io.StreamConnection;
import javax.microedition.io.HttpConnection;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.InputStream;
import java.io.IOException;
import java.io.OutputStream;

import java.util.Vector;

/**
 *
 * @author  paul
 * @version 
 */
public class SessionDemo extends javax.microedition.midlet.MIDlet
    implements CommandListener {

  Display display;

  boolean commandAvailable;
  CommandThread commandThread;
  
  Form outputForm;

  StringItem response;
      
  Command cmdExit;
  Command cmdOK;

  Vector cookies;

  public void startApp() {
    display = Display.getDisplay(this);


    outputForm = new Form(null);
    response = new StringItem(null,null);
    outputForm.append(response);
    cmdOK = new Command("OK",Command.SCREEN,1);
    cmdExit = new Command("Exit",Command.EXIT,1);
    outputForm.addCommand(cmdOK);
    outputForm.addCommand(cmdExit);
    outputForm.setCommandListener(this);

    commandAvailable = false;
    commandThread = new CommandThread(this);
    commandThread.start();

    getCount();
  }

  public void pauseApp() {
  }

  public void destroyApp(boolean unconditional) {
  }

  public void commandAction(Command cmd, Displayable d) {
    if (cmd == cmdExit) {
      destroyApp(false);
      notifyDestroyed();
    }
    else if (cmd == cmdOK)
      synchronized (this) {
        commandAvailable = true;
        notify();
      }
  }
   public void getCount() {

    HttpConnection conn = null;    
      InputStream is = null;
      OutputStream os = null;
      byte[] receivedData = null;
      try {
        String url = 
          "http://localhost/DDJ/servlet/CountServlet";
        conn = (HttpConnection)Connector.open(url);     
        conn.setRequestMethod(HttpConnection.POST);
        conn.setRequestProperty("User-Agent",
          "Profile/MIDP-1.0 Configuration/CLDC-1.0");
        conn.setRequestProperty("Content-type",
          "application/x-www-form-urlencoded");
        if (cookies == null) {
          cookies = getCookies(conn);
        }
        else {
          setCookies(conn);
        }
        is = conn.openInputStream();
        String contentType = conn.getType();
        int len = (int)conn.getLength();
        if (len > 0) {
          receivedData = new byte[len];
          int nb = is.read(receivedData);
        }
        else {
          receivedData = new byte[1024];
          int ch;
          len = 0;
          while ((ch = is.read()) != -1) {
            receivedData[len++] = (byte)ch;
          }
        }
        response.setText(new String(receivedData));
        display.setCurrent(outputForm);
      }
      catch (IOException e) {
        System.out.println(e.getMessage());
        e.printStackTrace();
      }
      catch (Exception e) {
        System.out.println(e.getMessage());
        e.printStackTrace();
      }
      finally {
        try {
          if (is != null) {
            is.close();
          }
          if (os != null) {
            os.close();
          }
          if (conn != null) {
            conn.close();
          }
        }
        catch (IOException e) {
        }
      }
    }

  private Vector getCookies(HttpConnection conn) throws IOException {
    Vector cookies = new Vector();
    int headerFieldIndex = 0;
    while (true) {
      String headerName = conn.getHeaderField(headerFieldIndex);
      if (headerName == null) {
        break;
      }
      String headerFieldKey = conn.getHeaderFieldKey(headerFieldIndex);
      ++headerFieldIndex;
      String hklc = headerFieldKey.toLowerCase();
      if (hklc.indexOf("cookie") < 0) {
        continue;
      }
      int scx = headerName.indexOf(';');
      String cookieValue;
      if (scx >= 0) {
        cookieValue = headerName.substring(0,scx);
      }
      else {
        cookieValue = headerName;
      }
      cookies.addElement(cookieValue);
    } 
    return cookies;
  }

  private void setCookies(HttpConnection conn) throws IOException {
    if (cookies.size() > 0) {
      StringBuffer sb = new StringBuffer();
      for (int i = 0; i < cookies.size(); ++i) {
        sb.append((String)cookies.elementAt(i));    
        if ((i + 1) < cookies.size()) {
          sb.append("; ");
        }
      }
      conn.setRequestProperty("Cookie", sb.toString());
    }
  }

  class CommandThread extends Thread {
    MIDlet parent;

    boolean exit = false;

    public CommandThread(MIDlet parent) {
      this.parent = parent;
    }

    public void run() {
      while (true) {
        synchronized(parent) {
          while(!commandAvailable) {
            try {
              parent.wait();
            }
            catch (InterruptedException e) {
            }
          }
          commandAvailable = false;
        }
    
        getCount();
      }
    }

 
  }
}    

