/*
 * SimpleMessaging.java
 *
 * Created on October 31, 2001, 6:47 PM
 */

package examples;

import java.io.*;
import javax.microedition.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

/**
 *
 * @author  Paul Tremblett
 * @version 1.0
 */
public class SimpleMessaging extends javax.microedition.midlet.MIDlet 
    implements CommandListener {

  Display display;
  
  MessageThread messageThread;

  Form outputForm;
  StringItem msg;
      
  Command cmdBack;
  Command cmdExit;

  public void startApp() {

    display = Display.getDisplay(this);

    outputForm = new Form("Message");
    msg = new StringItem(null,"Waiting...");
    outputForm.append(msg);
    cmdBack = new Command("Back",Command.BACK,1);
    outputForm.addCommand(cmdBack);
    cmdExit = new Command("Exit",Command.EXIT,1);
    outputForm.addCommand(cmdExit);
    outputForm.setCommandListener(this);

    display.setCurrent(outputForm);

    messageThread = new MessageThread();
    messageThread.start();
  }


  public void pauseApp() {
  }

  public void destroyApp(boolean unconditional) {
  }

  public void commandAction(Command cmd, Displayable d) {
    if (cmd == cmdExit) {
      destroyApp(false);
      notifyDestroyed();
    }
    else if (cmd == cmdBack) {
      outputForm.removeCommand(cmdBack);
      msg.setText("Waiting...`");
      display.setCurrent(outputForm);
    }
  }    

  class MessageThread extends Thread {

    StreamConnectionNotifier scn = null;
    StreamConnection sc = null;
    InputStream is = null;

    String url = "serversocket://:9191";

    public MessageThread() {
      try {
        scn = (StreamConnectionNotifier)Connector.open(url);
      }
      catch (IOException e) {
      }
    }

    public void run() {
      while(true) {
        try {
          sc = scn.acceptAndOpen();
          is = sc.openInputStream();
          int ch;
          StringBuffer sb = new StringBuffer();
          while ((ch = is.read()) != -1) {
            sb.append((char)ch);
          }
          is.close();
          msg.setText(sb.toString());
          outputForm.addCommand(cmdBack);
          display.setCurrent(outputForm);
        }
        catch (IOException e) {
        }
      }
    }

  }
}

