__guistructure__="""
#begin gui
# $Id: gengui.py,v 2.13.1.6 2001-08-15 21:31:33-05 brinkman Exp $

Name
	gengui

Type
	TextLayer

Menubar
	File	tearoff
		Open		self.load	shortcut:o
		Save		self.save	enabled:self.notEmpty() shortcut:T
		---
		Close		self.close	shortcut:c
		Exit		self.exit	shortcut:X
	Edit	tearoff
		Clear		self.clear
		Undo		self.undo	enabled:self.canUndo()
		Redo		self.redo	enabled:self.canRedo()
		---
		Find        enabled:self.notEmpty()         shortcut:f
		Find_again  enabled:self.searchString!=None shortcut:F
		Replace     enabled:self.notEmpty()         shortcut:r
	Help
		Help_window	self.help	shortcut:h
		About		self.about

Toolbar
	N
		Generate_Jython_Code self.generateJythonCode enabled:self.notEmpty()
		Run_Jython_Code self.runJythonCode enabled:self.notEmpty()
	S
		Check_in       self.checkIn	enabled:self.hasChanged()

#end
"""


import Config

import Default
from TextLayer import TextLayer

#begin preamble

#  $Id: gengui.py,v 2.13.1.6 2001-08-15 21:31:33-05 brinkman Exp $
#  A graphical user interface for generator.py.
#  Copyright (C) 2000  Peter Brinkmann (brinkman@math.uiuc.edu)
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""
gengui.py: A simple graphical user interface for generator.py.

$Id: gengui.py,v 2.13.1.6 2001-08-15 21:31:33-05 brinkman Exp $
"""
from MenuMaker import MenuMaker
from PowerFrame2 import PowerFrame
from StringIO import StringIO
from generator import generator

#end

#begin class gengui TextLayer
class gengui(TextLayer):
#end


#begin init
	"""
$Id: gengui.py,v 2.13.1.6 2001-08-15 21:31:33-05 brinkman Exp $

This class provides a simple graphical user interface for generator.py.
"""

	version="""
$Id: gengui.py,v 2.13.1.6 2001-08-15 21:31:33-05 brinkman Exp $
(c) 2000 Peter Brinkmann (brinkman@math.uiuc.edu)
gengui comes with ABSOLUTELY NO WARRANTY. This is free
software, and you are welcome to redistribute it under
certain conditions. For details refer to the GNU Public
License.
"""

	helptext="""
The following sample code should explain everything...

 #begin gui
 # example.dat: A sample GUI definition file.
 
 # $Id: gengui.py,v 2.13.1.6 2001-08-15 21:31:33-05 brinkman Exp $
 
 # comments are allowed!
 
 Name
 	example			# any valid Python class name is ok
 				# defaults to newgui
 
 Init
 	Default		# specifies configuration package, defaults to 'Default'
 	
 Type
 	PowerFrame	# choices are MenuMaker, PowerFrame,
 					# Layer, and TextLayer
 					# defaults to PowerFrame
 
 Menubar
 	File tearoff		# possible markers: tearoff, enabled:<flag>,
 						# extra:<dictionary>
 				# defaults to enabled:1
 		New		# cascading menu
 			Window
 			Copy	enabled:0
 			Cascade2
 				Spam	# yet another cascading menu
 		---		# separator
 		Open		# possible markers: enabled:<flag>
 		Save
 		---
 		Close	self.close shortcut:c
 					# can provide callback functions
 					# beginning with 'self.'
 					# keyboard accelerator <Ctrl>-c
 		Exit	self.exit shortcut:X
 					# keyboard accelerator <Ctrl>+<Shift>+x
 	Edit	extra:{'font':self.textfont}
 					# the extra tag creates a dictionary that will be passed
 					# to the constructor as a keyword argument
 					# this is also the place to put icons and such for java 1.2
 		Undo	extra:{'font':self.textfontlarge}
 		Redo		enabled:0
 		Checkbox1	unchecked	# a checkbox: options are
 						# checked or unchecked
 		Checkbox2	checked enabled:0
 		---
 		Item_with_spaces # underscores ('_') will become spaces (' ')
 	Test	enabled:0
 		Item
 		Another_item
 		# the extra tag creates a dictionary that'll be passed to the
 		# constructor as a keyword argument
 
 Toolbar
 	N			# tool bar at the top (north)
 		Button1		# possible markers: enabled:<flag>
 				# defaults to enabled:1
 		Button2	enabled:0
 
 	E
 		Button3
 		Button4
 	W
 		Button5 enabled:0
 		Exit self.exit	 # callback function beginning with 'self.'
 	S
 		Button6
 		Button7	enabled:0
 		Button8		extra:{'font':self.textfont}
 #end
"""

#end


#begin constructor
	def __init__(self,ms=None,data=None):
		# a simple constructor. Modify according to your needs!
		TextLayer.__init__(self,ms,data,80,30,1)
		self.name='Gumbie!'
		self.gen=generator()
		self.jl=None
		self.updateWidgets()
#end


	def start(self):
		# Modify at your own risk!
		self.MI_File=_('File')
		self.MI_Open=_('Open')
		self.MI_Save=_('Save')
		self.MI_Close=_('Close')
		self.MI_Exit=_('Exit')
		self.MI_Edit=_('Edit')
		self.MI_Clear=_('Clear')
		self.MI_Undo=_('Undo')
		self.MI_Redo=_('Redo')
		self.MI_Find=_('Find')
		self.MI_Find_again=_('Find again')
		self.MI_Replace=_('Replace')
		self.MI_Help=_('Help')
		self.MI_Help_window=_('Help window')
		self.MI_About=_('About')
		self.mBar=\
		  (
		    (self.MI_File,
		      (
		        (self.MI_Open,self.load,1,'o'
		        ),
		        (self.MI_Save,self.save,0,'T'
		        ),self.separator,
		        (self.MI_Close,self.close,1,'c'
		        ),
		        (self.MI_Exit,self.exit,1,'X'
		        ),
		      ),1,1
		    ),
		    (self.MI_Edit,
		      (
		        (self.MI_Clear,self.clear
		        ),
		        (self.MI_Undo,self.undo,0
		        ),
		        (self.MI_Redo,self.redo,0
		        ),self.separator,
		        (self.MI_Find,self.menuCallback_Find,0,'f'
		        ),
		        (self.MI_Find_again,self.menuCallback_Find_again,0,'F'
		        ),
		        (self.MI_Replace,self.menuCallback_Replace,0,'r'
		        ),
		      ),1,1
		    ),
		    (self.MI_Help,
		      (
		        (self.MI_Help_window,self.help,1,'h'
		        ),
		        (self.MI_About,self.about
		        ),
		      )
		    ),
		  )
		self.BT_Generate_Jython_Code=_('Generate Jython Code')
		self.BT_Run_Jython_Code=_('Run Jython Code')
		self.BT_Check_in=_('Check in')
		self.tBar=\
		  (
		    ('N',
		      (
		        (self.BT_Generate_Jython_Code,self.generateJythonCode,0
		        ),
		        (self.BT_Run_Jython_Code,self.runJythonCode,0
		        ),
		      )
		    ),
		    ('S',
		      (
		        (self.BT_Check_in,self.checkIn,0
		        ),
		      )
		    ),
		  )


#begin widgets
# put code for creating widgets here
#end


	def updateWidgets(self,e=None):
		self.menuitems[self.MI_File].setEnabled(1) # enable 'File'
		self.menuitems[self.MI_Open].setEnabled(1) # enable 'Open'
		self.menuitems[self.MI_Save].setEnabled(self.notEmpty()) # enable 'Save'
		self.menuitems[self.MI_Close].setEnabled(1) # enable 'Close'
		self.menuitems[self.MI_Exit].setEnabled(1) # enable 'Exit'
		self.menuitems[self.MI_Edit].setEnabled(1) # enable 'Edit'
		self.menuitems[self.MI_Clear].setEnabled(1) # enable 'Clear'
		self.menuitems[self.MI_Undo].setEnabled(self.canUndo()) # enable 'Undo'
		self.menuitems[self.MI_Redo].setEnabled(self.canRedo()) # enable 'Redo'
		self.menuitems[self.MI_Find].setEnabled(self.notEmpty()) # enable 'Find'
		self.menuitems[self.MI_Find_again].setEnabled(self.searchString!=None) # enable 'Find again'
		self.menuitems[self.MI_Replace].setEnabled(self.notEmpty()) # enable 'Replace'
		self.menuitems[self.MI_Help].setEnabled(1) # enable 'Help'
		self.menuitems[self.MI_Help_window].setEnabled(1) # enable 'Help window'
		self.menuitems[self.MI_About].setEnabled(1) # enable 'About'
		self.buttons[self.BT_Generate_Jython_Code].setEnabled(self.notEmpty()) # enable 'Generate Jython Code'
		self.buttons[self.BT_Run_Jython_Code].setEnabled(self.notEmpty()) # enable 'Run Jython Code'
		self.buttons[self.BT_Check_in].setEnabled(self.hasChanged()) # enable 'Check in'
#begin update
# put your updates for widgets here
#end


#begin callback menuCallback_Find
	def menuCallback_Find(self,e=None):
		# callback for 'Find'
		s=self.inputString('Find','Enter search string:')
		if s!=None:
			if not self.find(s):
				self.infoBox('Not found','String '+s+' not found.')
#end


#begin callback menuCallback_Find_again
	def menuCallback_Find_again(self,e=None):
		# callback for 'Find again'
		if self.searchString!=None:
			if not self.findAgain():
				self.infoBox('Not found','String '+self.searchString+
							' not found.')
		else:
			self.errorBox('No search string available!')
#end


#begin callback menuCallback_Replace
	def menuCallback_Replace(self,e=None):
		# callback for 'Replace'
		s1=self.inputString('Search string','Find:',self.searchString)
		if s1!=None:
				s2=self.inputString('Replace string','Replace by:',None)
				if s2!=None:
					self.replace(s1,s2)
#end


#begin misc

	def generateJythonCode(self,e=None):
		# callback for 'Generate Jython code'
		try:
			inp=StringIO(self.getText())
			out=StringIO()
			self.gen.generateCode(inp,out)
			self.setDataSafely(out.getvalue())
			inp.close()
			out.close()
		except:
			self.exceptionBox()


	def runJythonCode(self,e=None):
		# callback for 'Run Jython code'
		if self.doubleCheck():
			try:
				exec(self.getText())
			except:
				self.exceptionBox()

#end


#begin main

if __name__=='__main__':
	print """
$Id: gengui.py,v 2.13.1.6 2001-08-15 21:31:33-05 brinkman Exp $
(c) 2000 Peter Brinkmann (brinkman@math.uiuc.edu)
gengui comes with ABSOLUTELY NO WARRANTY. This is free
software, and you are welcome to redistribute it under
certain conditions. For details refer to the GNU Public
License.
"""
	from LayeredFrame2 import OneLayer
	f=OneLayer(gengui)

#end


