
public void opaqueInit(String alg, int size) throws GeneralSecurityException
{
    AlgorithmParameterGenerator pgen;
    AlgorithmParameters params;
    KeyGenerator kgen;
    SecretKey key;
    String alt;
    int n;

    n   = alg.indexOf('/');
    alt = (n > 0) ? alg.substring(0,n) : alg;

    try{
        pgen = AlgorithmParameterGenerator.getInstance(alt);
        pgen.init(size);
        params = pgen.generateParameters();
    }
    catch(NoSuchAlgorithmException e)
    {
        System.out.println("Warning, no parameter generator for "+alg);
        params = null;
    }
    kgen = KeyGenerator.getInstance(alt);
    kgen.init(size);
    key = kgen.generateKey();

    doSomething(key, params, alg);

    return;
}
